NAME
====

Shodan::API::Exploit

DESCRIPTION
===========

A [raku-lang](https://raku.org/) client for [Shodan](https://www.shodan.io/), a search engine for Internet-connected devices. This client provides an interface for the [Shodan Exploit API](https://developer.shodan.io/api/exploits/rest).

METHODS
=======

### method exploit-search

```raku
method exploit-search(
    Str :$query!,
    Str :$facets = "author,platform,port,source,type",
    Int :$page = 1
) returns Hash
```

Search across a variety of data sources for exploits and use facets to get summary information.

### method exploit-count

```raku
method exploit-count(
    Str :$query!,
    Str :$facets = "author,platform,port,source,type"
) returns Hash
```

This method behaves identical to the "/search" method with the difference that it doesn't return any results.

AUTHOR
======

"Sarah Fuller", `<"sarah at averna . id . au"> `

COPYRIGHT AND LICENSE
=====================

Copyright 2022 Sarah Fuller This library is free software; you can redistribute it and/or modify it under the Artistic License 2.0.

